'use strict';

// eslint-disable-next-line import/no-extraneous-dependencies
let main = (() => {var _ref5 = _asyncToGenerator(











































































































  function* () {
    if (!global.gc) {
      console.log('GC not present');
    }

    const wFResults = [];
    const jWResults = [];

    for (let i = 0; i < 10; i++) {
      console.log('-'.repeat(75));

      profile('worker farm');
      const wF = yield testWorkerFarm();
      profileEnd('worker farm');
      yield sleep(3000);
      // eslint-disable-next-line no-undef
      global.gc && gc();

      profile('jest worker');
      const jW = yield testJestWorker();
      profileEnd('jest worker');
      yield sleep(3000);
      // eslint-disable-next-line no-undef
      global.gc && gc();

      wFResults.push(wF);
      jWResults.push(jW);

      console.log('jest-worker:', jW);
      console.log('worker-farm:', wF);
    }

    let wFGT = 0;
    let wFPT = 0;
    let jWGT = 0;
    let jWPT = 0;

    for (let i = 0; i < 10; i++) {
      wFGT += wFResults[i].globalTime;
      wFPT += wFResults[i].processingTime;

      jWGT += jWResults[i].globalTime;
      jWPT += jWResults[i].processingTime;
    }

    console.log('-'.repeat(75));
    console.log('total worker-farm:', { wFGT, wFPT });
    console.log('total jest-worker:', { jWGT, jWPT });

    console.log('-'.repeat(75));
    console.log(
    `% improvement over ${calls} calls (global time):`,
    100 * (wFGT - jWGT) / wFGT);


    console.log(
    `% improvement over ${calls} calls (processing time):`,
    100 * (wFPT - jWPT) / wFPT);

  });return function main() {return _ref5.apply(this, arguments);};})();var _build;function _load_build() {return _build = _interopRequireDefault(require('../../build'));}function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};}const workerFarm = require('worker-farm');const sleep = ms => new Promise(resolve => setTimeout(resolve, ms));const calls = 10000;const threads = 6;function testWorkerFarm() {return new Promise((() => {var _ref = _asyncToGenerator(function* (resolve, reject) {let countToFinish = (() => {var _ref2 = _asyncToGenerator(function* () {if (++count === calls) {workerFarm.end(api);const endTime = Date.now(); // Let all workers go down.
            yield sleep(2000);resolve({ globalTime: endTime - startTime - 2000, processingTime: endTime - startProcess });}});return function countToFinish() {return _ref2.apply(this, arguments);};})();const startTime = Date.now();let count = 0;const api = workerFarm({ autoStart: true, maxConcurrentCallsPerWorker: 1, maxConcurrentWorkers: threads }, require.resolve('./workers/worker_farm'), ['loadTest']); // Let all workers come up.
      yield sleep(2000);const startProcess = Date.now();for (let i = 0; i < calls; i++) {const promisified = new Promise(function (resolve, reject) {api.loadTest(function (err, result) {if (err) {reject(err);} else {resolve(result);}});});promisified.then(countToFinish);}});return function (_x, _x2) {return _ref.apply(this, arguments);};})());}function testJestWorker() {return new Promise((() => {var _ref3 = _asyncToGenerator(function* (resolve, reject) {let countToFinish = (() => {var _ref4 = _asyncToGenerator(function* () {if (++count === calls) {farm.end();const endTime = Date.now(); // Let all workers go down.
            yield sleep(2000);resolve({ globalTime: endTime - startTime - 2000, processingTime: endTime - startProcess });}});return function countToFinish() {return _ref4.apply(this, arguments);};})();const startTime = Date.now();let count = 0;const farm = new (_build || _load_build()).default(require.resolve('./workers/jest_worker'), { exposedMethods: ['loadTest'], forkOptions: { execArgv: [] }, workers: threads });farm.getStdout().pipe(process.stdout);farm.getStderr().pipe(process.stderr); // Let all workers come up.
      yield sleep(2000);const startProcess = Date.now();for (let i = 0; i < calls; i++) {const promisified = farm.loadTest();promisified.then(countToFinish);}});return function (_x3, _x4) {return _ref3.apply(this, arguments);};})());}function profile(x) {console.profile(x);}function profileEnd(x) {console.profileEnd(x);}main();